
 tour(N) :- M is N*N-1, solve(M,N,1,1,[1,1]).

 solve(0,N,_,_,IJ) :- forI(0,IJ,N).

 solve(M,N,I,J,IJ) :- next(I,J,I1,J1),
                      I1>=1, J1>=1, I1=<N,J1=<N, \+ memb(I1,J1,IJ),
                      M1 is M-1, solve(M1,N,I1,J1, [I1,J1|IJ]).

 next(I,J,I1,J1) :- I1 is I-2,J1 is J-1;
                    I1 is I-2,J1 is J+1;
                    I1 is I-1,J1 is J-2;
                    I1 is I-1,J1 is J+2;
                    I1 is I+1,J1 is J-2;
                    I1 is I+1,J1 is J+2;
                    I1 is I+2,J1 is J-1;
                    I1 is I+2,J1 is J+1.

 memb(X,Y,[X,Y|_]).
 memb(X,Y,[_,_|Z]) :- memb(X,Y,Z).


%------------------------------  output  -----------------------------------

 forI(N,_,N).
 forI(I,IJ,N) :- I1 is I+1, writeln(' '), forJ(I1,0,IJ,N), forI(I1,IJ,N).
  
 forJ(_,N,_,N).
 forJ(I,J,IJ,N) :- J1 is J+1, N1 is N*N, writeIJ(I,J1,IJ,N1), forJ(I,J1,IJ,N). 
  
 writeIJ(I,J,[I1,J1|_],N) :- I=:=I1, J=:=J1,write(' '), writeN(N).

 writeIJ(I,J,[_,_|IJ],N) :- N>0, N1 is N-1, writeIJ(I,J,IJ,N1).

 writeN(N) :- N<10, write(' '), write(N);
              N>9, write(N).
